
* Program 7.1:  
Using the N function to determine the number of  
non-missing values in a list of variables
***Primary functions: N, MEAN;

DATA QUIZ;
INPUT QUIZ1-QUIZ10;
***Compute quiz average if 8 or more quizzes taken;
IF N(OF QUIZ1-QUIZ10) GE 8 THEN QUIZ_AVE = MEAN(OF QUIZ1-QUIZ10);
DATALINES;
90 88 79 100 97 96 94 95 93 88
60 90 66 77 . . . 88 84 86
90 . . 90 90 90 90 90 90 90
;
run;

TITLE "Listing of Data Set QUIZ";
PROC PRINT DATA=QUIZ NOOBS HEADING=H;
RUN;


* Program 7.2:  
Computing a SUM and MEAN of a list of variables, only if
there are no missing values
***Primary functions: NMISS, MEAN and SUM
***Other function: N;

DATA NOMISS;
INPUT X1-X3 Y Z;
IF NMISS(OF X1-X3,Y,Z) EQ 0 THEN DO;
***An alternative statement is:
IF N(OF X1-X3,Y,Z) EQ 5 THEN DO;
   SUM_VARS = SUM(OF X1-X3,Y,Z);
   AVERAGE = MEAN(OF X1-X3,Y,Z);
END;
DATALINES;
1 2 3 4 5
9 . 8 7 6
8 8 8 8 8
;

TITLE "Listing of Data Set NOMISS";
PROC PRINT DATA=NOMISS NOOBS;
RUN;


* Program 7.3:  
Computing a mean, median, and sum of eight variables, only
if there are at least six non-missing values
***Primary functions: N, MEAN, MEDIAN, SUM;

DATA SCORE;
INPUT (ITEM1-ITEM8)(1.);
IF N(OF ITEM1-ITEM8) GE 6 THEN DO;
   MEAN = MEAN(OF ITEM1-ITEM8);
   MEDIAN = MEDIAN(OF ITEM1-ITEM8);
   SUM = SUM(OF ITEM1-ITEM8);
END;
DATALINES;
12345678
1.3.5678
1...5678
;
RUN;

TITLE "Listing of SCORE";
PROC PRINT DATA=SCORE NOOBS;
RUN;


* Program 7.4:  
Computing a range, interquartile range, and standard
deviation for each subject
***Primary functions: RANGE, IQR, and STD;

DATA HOME_ON_THE_RANGE;
INPUT SUBJECT X1-X10;
RANGE = RANGE(OF X1-X10);
IQR = IQR(OF X1-X10);
SD = STD(OF X1-X10);
DATALINES;
1  1 2 3 4 5 6 7 8 9 10
2  9 7 4 1 15 0 . 2 7 4
3  1 3 5 7 9 11 13 15 20 100
;
RUN;

TITLE "Listing of Data Set HOME_ON_THE_RANGE";
PROC PRINT DATA=HOME_ON_THE_RANGE;
ID SUBJECT;
RUN;


* Program 7.5:  
Program to read hourly temperatures and determine the
daily minimum and maximum temperature
***Primary functions: MIN and MAX;

DATA MIN_MAX_TEMP;
INPUT DATE : mmddyy.  / TEMP1-TEMP24;
MIN_TEMP = MIN(OF TEMP1-TEMP24);
MAX_TEMP = MAX(OF TEMP1-TEMP24);
KEEP MIN_TEMP MAX_TEMP DATE;
FORMAT DATE MMDDYY10.;
DATALINES;
05/1/2002
38 38 39 40 41 42 55 58 60 60 59 62 66 70 75 77 60 59 58 57 54 52 51 50
05/02/2002
36 41 39 40 41 46 57 59 63 . 59 62 64 72 79 80 78 62 62 62 60 50 55 55
;
RUN;

TITLE "Listing of Data Set MIN_MAX_TEMP";
PROC PRINT DATA=MIN_MAX_TEMP NOOBS;
RUN;


* Program 7.6:  
Computing the three lowest golf scores for each player
(using the SMALLEST function)
***Primary function: SMALLEST;

DATA GOLF;
INFILE DATALINES MISSOVER;
INPUT ID $ SCORE1-SCORE8;
LOWEST = SMALLEST(1 ,OF SCORE1-SCORE8);
NEXT_LOWEST = SMALLEST(2, OF SCORE1-SCORE8);
THIRD_LOWEST = SMALLEST(3, OF SCORE1-SCORE8);
DATALINES;
001 100 98 . . 96 93
002 90 05 07 99 103 106 110
003 110 120
;
RUN;

TITLE "Listing of Data Set GOLF";
PROC PRINT DATA=GOLF NOOBS;
RUN;


* Program 7.7:  
Computing a grade based on the three highest scores
***Primary function: LARGEST, N
***This program will compute a grade based on the 3 highest
   (out of 9) scores.  If there are fewer than 5 non-missing scores,
   a missing value will be returned;

DATA HIGH_3;
INPUT SCORE1-SCORE9;
IF N(OF SCORE1-SCORE9) LT 5 THEN RETURN;
SUM = LARGEST(1,OF SCORE1-SCORE9) + 
      LARGEST(2,OF SCORE1-SCORE9) +  
      LARGEST(3,OF SCORE1-SCORE9);
GRADE = SUM / 3;
DATALINES;
90 100 89 88 10 . . 29 77
. . . . . 100 99 98 97
10 20 30 40 50 60 70 80 90
;
RUN;

TITLE "Listing of Data Set HIGH_5";
PROC PRINT DATA=HIGH_3 NOOBS;
RUN;


* Program 7.9:  
Using the PCTL function to determine 25th, 50th, and 75th
percentile in a list of values
***Primary function: PCTL
***Other functions: RANNOR;

***Generate data set for testing;
DATA TEMPERATURE;
ARRAY T[24]; ***Temperature for each hour;
DO DAY = 1 TO 5;
***T values normally distributed with mean = 70 and standard deviation = 10;
DO HOUR = 1 TO 24;
  T[HOUR] = 10*RANNOR(0) + 70;
END;
   OUTPUT;
END;
KEEP T1-T24 DAY;
RUN;

TITLE "'FAKE' Dats Set TEMPERATURE";
PROC PRINT DATA=TEMPERATURE;
RUN;

DATA PERCENTILE;
SET TEMPERATURE;
P25 = PCTL(25, OF T1-T24);
P50 = PCTL(50, OF T1-T24);
P75 = PCTL(75, OF T1-T24);
IQR = P75 - P25;
LABEL P25 = "25th Percentile"
      P50 = "Median"
      P75 = "75th Percentile"
      IQR = "Inter-quartile Range";
RUN;

TITLE "Listing of Data Set PERCENTILE";
PROC PRINT DATA=PERCENTILE NOOBS LABEL;
VAR DAY P25 P50 P75 IQR;
RUN;


* Program 7.10:  
Program to compute a quiz grade by dropping none, one, or
two of the lowest quiz scores, depending on how many
quizzes were taken
***Primary function: ORDINAL
***Other functions: N, MEAN, and SUM;

DATA QUIZ_AVE;
INPUT ID : $3. QUIZ1-QUIZ9;
N_OF_QUIZZES = N(OF QUIZ1-QUIZ9);
SELECT (N_OF_QUIZZES);
    WHEN (9)  QUIZ_AVE = (SUM(OF QUIZ1-QUIZ9) -
                         ORDINAL(1,OF QUIZ1-QUIZ9) -
                         ORDINAL(2,OF QUIZ1-QUIZ9))/7;
    WHEN (8)  QUIZ_AVE = (SUM(OF QUIZ1-QUIZ9) - 
                         ORDINAL(2,OF QUIZ1-QUIZ9))/7;
    OTHERWISE QUIZ_AVE = MEAN(OF QUIZ1-QUIZ9);
END;
DATALINES;
001 6 7 8 9 8 7 6 7 8
002 6 8 8 8 8 8 8 8 .
003 7 8 9 . . . . . .
004 9 9 1 9 9 9 9 . .
;
RUN;

TITLE "Listing of Data Set QUIZ_AVE";
PROC PRINT DATA=QUIZ_AVE NOOBS;
RUN;


* Program 7.12: 
Sorting values within an observation
*** Primary function: CALL SORTN;

DATA UNSORTED;
INPUT X1-X10;
DATALINES;
5 2 9 1 3 6 . 22 7 0
9 9 9 9 2 3 4  5 . .
;
RUN;

TITLE 'DATA SET UNSORTED';
PROC PRINT DATA=UNSORTED;
RUN;

DATA SORTED;
SET UNSORTED;
CALL SORTN(OF X1-X10);
RUN;

TITLE 'DATA SET SORTED';
PROC PRINT DATA=SORTED;
RUN;
